﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.OleDb;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using C1.Win.C1FlexGrid;

namespace ChildGrid_FGRowDetail
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            //set datasource
            c1FlexGrid1.DataSource = GetDataSource();
            c1FlexGrid1.DataMember = "Customers";

            //setup custom row detail provider
            c1FlexGrid1.RowDetailProvider = (g, r) => 
            { 
                var rowDetail = new CustomFGRowDetail();
                //handle custom event, which tells us which Row and col is selected in child grid
                return rowDetail;
            };

            c1FlexGrid1.RowDetailsVisibilityMode = RowDetailsVisibilityMode.Collapsed;
        }


        private void mnuRightToLeft_Click(object sender, EventArgs e)
        {
            if (c1FlexGrid1.RightToLeft == RightToLeft.Yes)
            {
                c1FlexGrid1.RightToLeft = RightToLeft.No;
                mnuRightToLeft.Text = "RightToLeft.No";
           }
            else

            {
                c1FlexGrid1.RightToLeft = RightToLeft.Yes;
                mnuRightToLeft.Text = "RightToLeft.Yes";

            }
        }

        /// <summary>
        /// Sample DataSource for the Grid
        /// </summary>
        public DataSet GetDataSource()
        {
            //connection string to Common Sample Database installed with C1
            var path = Environment.GetFolderPath(Environment.SpecialFolder.Personal) + @"\ComponentOne Samples\Common";
            var conn = @"provider=microsoft.jet.oledb.4.0;data source={0}\c1nwind.mdb;";
            var connString = string.Format(conn, path);

            DataSet ds = new DataSet();

            //Customers table
            string sql = "select * from [Customers]";
            var da = new OleDbDataAdapter(sql, connString);
            da.Fill(ds, "Customers");

            //orders table
            sql = "select * from [Orders]";
            da = new OleDbDataAdapter(sql, connString);
            da.Fill(ds, "Orders");

            //add relation
            ds.Relations.Add("Customer_Orders", ds.Tables[0].Columns["CustomerID"], ds.Tables[1].Columns["CustomerID"]);

            return ds;
        }
    }
}
